<?php 
/*
 * Fonctions en contact avec la base de donne 
 * 
 */

/** But :
 * Verifier si une entre rponds dj au critre
 *
 ** Entre(s)/Sortie(s) :
 * @param $table
 * @param $nom_colonne
 * @param $valeur
 * @return booleen (true : une entre y rponds / false : aucune entre y rponds)
 *
 * @author Lim Vincent
 */
function valeur_existe($table,$nom_colonne,$valeur)
{
	
	$condition='WHERE '. $nom_colonne . '=' . $valeur;
	
	$nombreEntree=$table->compter_entree($condition);
	
	if($nombreEntree>0)
	{
		return true; //la donne existe dj
	}
	else
	{
		return false;
	}
}

/** But :
 * Renvoie une chaine avec les ' ' autour
 * 
 ** Entre(s)/Sortie(s) :
 * @param $string
 * @return unknown_type
 *
 * @author Lim Vincent
 */
function addquote($string)
{
	return('\'' . $string . '\'');
}

//-----------------------------------------------------------------------------------------------
//-------------------------- AFFICHAGE DE DONNEES EN HTML ------------------------
//-----------------------------------------------------------------------------------------------

/** But :
 * Cre une liste d'option
 *
 ** Entre(s)/Sortie(s) :
 * @param $reponseSQL
 * @param $nombre_colonne_affiche
 * @return void (rien)
 *
 * @author Lim Vincent
 */
function liste_option($reponseSQL,$nombre_colonne_affiche)
{
	$nombre_iteration=0;
	while($ligne_parcouru=mysql_fetch_array($reponseSQL))
	{
		echo '<option value="' . $ligne_parcouru[0] . '">';
		
		for ( $i = 1; $i <= $nombre_colonne_affiche ; $i++)
		{
			echo htmlspecialchars(stripslashes($ligne_parcouru[$i]));
		}

		echo '</option>';
		
		$nombre_iteration++;
	}
	
	//si la boucle ne s'est pas effectuer une fois on affiche l'option vide
	if($nombre_iteration==0)
	{
		echo '<option>vide</option>';
	}
}

/** But :
 * Afficher une liste en ordonant par un critre
 *
 ** Entre(s)/Sortie(s) :
 * @param $table
 * @param $affichage
 * @param $classerPar
 * @return void (rien)
 *
 * @author Lim Vincent
 */
function afficher_liste($table,$classerPar)
{
	$reponseSQL=$table->select('*','ORDER BY ' . $classerPar . ' ASC');
	liste_option($reponseSQL,1);
}


/** But :
 * Donne la valeur contenu dans une colonne si activer_bool_erreur et  true il retourne un booleen false 
 * quand la colonne ne contient rien.
 * Enlve galement les \ pour viter les problmes du  la protection contre les injections htmls (affichage de \ en plus si magic quote est activ)
 * 
 ** Entre(s)/Sortie(s) :
 * @param $ligne_parcouru
 * @param $nom_colonne
 * @param $activer_bool_erreur
 * @return bool/valeur_de_la_colonne
 *
 * @author Lim Vincent
 */
function donner_valeur_colonne($ligne_parcouru,$nom_colonne,$activer_bool_erreur)
{
	//cas ou on doit retourner un booleen s'il y a une erreur
	if($activer_bool_erreur==true)
	{
		if($ligne_parcouru[$nom_colonne]=='')
		{
			//si la colonne est vide on retourne false
			return false;
		}
		//sinon on retourne la valeur
		//en prvenant l'injection de code html
		return htmlspecialchars(stripslashes($ligne_parcouru[$nom_colonne]));
	}
	
	//cas ou on doit pas retourner un booleen
	if($ligne_parcouru[$nom_colonne]=='')
	{
		return 'N.C.';
	}
	
	return htmlspecialchars(stripslashes($ligne_parcouru[$nom_colonne]));
}
?>