<?php
/*
 * Nature des objets contenues [objets-bdd]:
 * - les objets pouvant faire des oprations sur la base de donne
 * - les objets qui ont besoin d'avoir accs  la base de donne
 */

/** But :
 * Permet la connection  la base de donne
 ** Entre(s)/Sortie(s) :
 * Aucune
 *
 * @author Lim Vincent
 */
class base_de_donnee
{
	private $nom_bdd; 	//bdd : base de donne
	
	function __construct($nom)
	{	
		$this->nom_bdd=$nom;
		$this->connect();
	}

	function __destruct()
	{
		$this->disconnect();
	}

	// ---------------------------
	// Fonctions de base (connection/deconnection)
	// ---------------------------
		function connect()
		{
			// si la connection  la base de donne choue, le script s'interrompt et le message spcifi en paramtre de die s'affiche
			mysql_connect("spiderman-2:3306.laas.fr","stagiaire","2imdp") or die('La connection  la base de donne  chou');
			mysql_select_db($this->nom_bdd);
		}
		
		function disconnect()
		{
			mysql_close();
		}
}


/** But :
 * Permet d'effectuer des oprations sur les tables.
 *
 ** Entres/Sorties :
 * Aucune
 *
 * @author Lim Vincent
 */
class table
{
	private $nomTable;
	
	/*
	 * Constructeur
	 */
	function __construct($nom)
	{
		$this->nomTable=$nom;
	}
	
	// ---------------------------------
	// Operations de base
	// ---------------------------------
	
		/** But :
		 * Effectuer une requte SELECT sur la table et renvoyer son resultat
		 *
		 ** Entre(s)/Sortie(s) :
		 * @param $colonnes (contient le nom des colonnes voulu)
		 * @param $autre (peut contenir les arguments optionnels)
		 * @return $reponseSQL (chaine de caractre)
		 */
		function select($colonnes, $condition)
		{
			
			$reponseSQL=mysql_query('SELECT ' . $colonnes . ' FROM ' . $this->nomTable . ' ' . $condition);
			return $reponseSQL;
	
		}
	
		/** But :
		 * Effectuer une requte INSERT sur la table
		 *
		 ** Entre(s)/Sortie(s) :
		 * @param $nomColonnes
		 * @param $valeurs
		 * @return void (rien)
		 */
		function insert($nomColonnes, $valeurs)
		{
			// TODO : renvoyer l'id de l'lment insr ?
			mysql_query('INSERT INTO ' . $this->nomTable . ' (' . $nomColonnes . ') VALUES (' . $valeurs . ')');
		}
	
		
		/** But :
		 * Effectuer une requte UPDATE sur la table
		 *
		 ** Entre(s)/Sortie(s) :
		 * @param $valeursEtNomColonnes
		 * @param $id 
		 * @param $condition 
		 * @return void (rien)
		 */
		function update($valeursEtNomColonnes,$id,$condition)
		{
			if($id!='')
			{
				$condition = 'WHERE id_' . $this->nomTable . '=' . $id; 
				mysql_query('UPDATE ' . $this->nomTable . ' SET ' . $valeursEtNomColonnes . ' ' . $condition);
			}
			elseif($condition!='')
			{
				mysql_query('UPDATE ' . $this->nomTable . ' SET ' . $valeursEtNomColonnes . ' ' . $condition);
			}
		}
		
		/** But :
		 * Effacer une requte DELETE sur la table 
		 *
		 ** Entre(s)/Sortie(s) :
		 * @param $valeurId
		 * @param $condition
		 * @return void (rien)
		 */
		function delete($valeurId,$condition)
		{
			//$condition est prsent temporairement : problme pos par les tables renommes
			if($valeurId!='')
			{
				mysql_query('DELETE FROM ' . $this->nomTable . ' WHERE id_' . $this->nomTable . '=' . $valeurId);
			}
			elseif($condition!='')
			{
				mysql_query('DELETE FROM ' . $this->nomTable . ' ' . $condition );
			}
		}
		
	// ---------------------------------
	// Operations Avancs (mthode qui se servent des mthodes de l'objet lui mme)
	// ---------------------------------
		/** But :
		 * Donner le nombre d'entre contenu rpondant  la condition
		 *
		 ** Entre(s)/Sortie(s) :
		 * @param $table
		 * @param $autre (conditions optionnelles de la requte SELECT)
		 * @return int (le nombre d'entre compt)
		 */
		function compter_entree($condition)
		{
			$reponseSQL=$this->select('COUNT(*)',$condition);
			
			$reponseSQL = mysql_fetch_array($reponseSQL);
			
			return ( (int) $reponseSQL[0] );
		}
	
}

/** But :
 * Permet d'empcher les failles XSS (cross site site : exemple injection SQL)
 *
 ** Entres/Sorties :
 * Aucune
 *
 * @author Lim Vincent
 */
class securite
{
	/** But :
	 * Transformer une chaine reu en chaine dpourvue d'espace avant et aprs
	 * Empcher une injection de code SQL
	 *
	 ** Entre(s)/Sortie(s) :
	 * @param $chaine
	 * @return string
	 */
	function sql($chaine)
	{
		return mysql_real_escape_string(trim($chaine));
	}
	
	/** But :
	 * Transformer une chaine reu en chaine dpourvue d'espace avant et aprs
	 * Empcher une injection de code SQL
	 * Transformer la chaine en valeur SQL (avec ' avant et aprs)
	 *
	 ** Entre(s)/Sortie(s) :
	 * @param $chaine
	 * @return string
	 */
	function toValueSQL($chaine)
	{
		return ( '\'' . mysql_real_escape_string(trim($chaine)) . '\'' );	
	}

	/** But :
	 * Transformer une chaine reu en chaine dpourvue de ' avant et aprs (paramtre magic quote activ)
	 * Empcher une injection de code HTML
	 * Transformer les caractres < et > en leur quivalent
	 *
	 ** Entre(s)/Sortie(s) :
	 * @param $chaine
	 * @return string
	 */
	function bdd_html($chaine)
	{
		return htmlspecialchars(stripslashes($chaine));
	}
}
?>